#include <fstream.h>

ifstream IN;
int Run;
int Width;
int Words;
char Word[80][1000];
int BestLayout;
int Best;

void Input()
{
  IN >> Width;
  if (Width == 0) return;
  Words = 0;
  while (true) {
    if (IN.peek() == '\n') IN.get();
    if (IN.peek() == '\n') break;
    IN >> Word[Words];
    Words++;
    cout << Word[Words-1];
  }
}

int Rank(int Layout)
{
  int Bad = 0;
  int W = 0;
  while (W < Words) {
    int w = 0;
    int l = 0;
    while (true) {
      w++;
      l += strlen(Word[W]);
      W++;
      if ((Layout & 1<<(W-1)) == 0) continue;
      if (w==1 && l!=Width) {
        Bad += 500; 
        break;
      }
      if (w == 1) break;
      int spc = Width - l - (w-1);
      while (spc > 0) {
        int x = spc / w;
        Bad += x*x;
        spc -= x;
        w--;
      }
      break;
    }
  }
  return Bad;
}

void Output()
{
  int W = 0;
  while (W < Words) {
    int w = 0;
    int l = 0;
    do {
      l += strlen(Word[W+w]);
      w++;
    } while ((BestLayout & 1<<(W+w)) == 0);
    for (int i=0; i<w; i++) cout << Word[W+i] << " ";
    cout << endl;
    W += w;
  }
}

int main()
{
  IN.open("formatting.in");
  for (Run=1; true; Run++) {
    Input();
    if (Width == 0) break;
    int Possibilities = 1;
    for (int i=1; i<Words; i++) Possibilities *= 2;
    Best = 1000000;
    for (int Layout=Possibilities; Layout<2*Possibilities; Layout++) {
      int Value = Rank(Layout);
      if (Value < Best) {
        Best = Value;
        BestLayout = Layout;
      }
    }
    Output();
  }
  IN.close();
  return 0;
}
