#include <fstream.h>

ifstream IN;
int Run;
int Size,Number;

char Top[11]      = "- -- -----";
char Middle[11]   = "  ----- --";
char Bottom[11]   = "- -- -- --";
char UpLeft[11]   = "|   ||| ||";
char UpRight[11]  = "|||||  |||";
char BotLeft[11]  = "| |   | | ";
char BotRight[11] = "|| |||||||"; 

int Digit[10];
int Digits;

void Input()
{
  IN >> Size >> Number;
}

void Calculate()
{
  int pos = 9;
  Digits = 0;
  while (Digits==0 || Number>0) {
    Digit[pos] = Number%10;
    Number /= 10;
    pos--;
    Digits++;
  }
}

void print(char c,int Count)
{
  for (int i=0; i<Count; i++) cout << c;
}

void Output()
{
  for (int d=10-Digits; d<10; d++) {
    cout << ' ';
    print(Top[Digit[d]],Size);
    cout << ' ';
    cout << ' ';
  }
  cout << endl;
  
  for (int line=0; line<Size; line++) {
    for (int d=10-Digits; d<10; d++) {
      cout << UpLeft[Digit[d]];
      print(' ',Size);
      cout << UpRight[Digit[d]];
      cout << ' ';
    }
    cout << endl;
  }

  for (int d=10-Digits; d<10; d++) {
    cout << ' ';
    print(Middle[Digit[d]],Size);
    cout << ' ';
    cout << ' ';
  }
  cout << endl;

  for (int line=0; line<Size; line++) {
    for (int d=10-Digits; d<10; d++) {
      cout << BotLeft[Digit[d]];
      print(' ',Size);
      cout << BotRight[Digit[d]];
      cout << ' ';
    }
    cout << endl;
  }

  for (int d=10-Digits; d<10; d++) {
    cout << ' ';
    print(Bottom[Digit[d]],Size);
    cout << ' ';
    cout << ' ';
  }
  cout << endl;
}

int main()
{
  IN.open("lcd.in");
  for (Run=1; true; Run++) {
    Input();
    if (Size==0 && Number==0) break;
    Calculate();
    Output();
    cout << endl;
  }
  IN.close();
  return 0;
}
