#include <fstream.h>
#include <stdlib.h>

ifstream IN;
int Run;
int N;
int Step[10];
char Leaf[1025];
int X[10];

void Input()
{
  IN >> N;
  if (N == 0) return;
  for (int i=0; i<N; i++) {
    char s[5];
    IN >> s;
    Step[i] = atoi(s+1)-1;
  }
  IN >> Leaf;
}

void Output()
{
  cout << "S-Tree #" << Run << ":" << endl;
  int Cases;
  IN >> Cases;
  for (int Case=0; Case<Cases; Case++) {
    char Help[10];
    IN >> Help;
    for (int i=0; i<N; i++) X[i] = Help[i]-'0';
    int Pos = 0;
    int Displacement = 1;
    for (int i=1; i<N; i++) Displacement *= 2;
    for (int i=0; i<N; i++) {
      // cout << "X[" << Step[i] << "] = " << X[Step[i]] << endl;
      if (X[Step[i]] == 1) Pos += Displacement;
      Displacement /= 2;
    }
    cout << Leaf[Pos];
  }
  cout << endl << endl;  
}

int main()
{
  IN.open("stree.in");
  for (Run=1; true; Run++) {
    Input();
    if (N == 0) break;
    Output();
  }
  IN.close();
  return 0;
}
