#include <fstream.h>

ifstream IN;
int Run;

struct SComputers {int display;
                   int bugyear;
                   int jumpto;
                   int interval; };

SComputers Computer[20];


int NrComputers;



void Input()
{
  for (int i=0; i < NrComputers; i++) {
    IN >> Computer[i].display;
    IN >> Computer[i].jumpto;
    IN >> Computer[i].bugyear;
    Computer[i].interval = Computer[i].bugyear - Computer[i].jumpto;
  }
}

bool CheckComputer(int c, int display, int actual)
{
  int d = Computer[c].jumpto;
  for (int y=Computer[c].jumpto;y<actual;y++) {
    d++;
    if (d==Computer[c].bugyear) d = Computer[c].jumpto;
  }
  //cout << d << endl;
  if (d==Computer[c].display) return true;
  else return false;
}


int GetYear()
{
  if (NrComputers==1) return Computer[0].display;
  for(int y=Computer[0].display; y<10000; y+= Computer[0].interval) {
    bool found = true;   
    for (int c=1;c<NrComputers;c++) 
      if (!CheckComputer(c,Computer[0].display,y)) found=false;
    if (found) {
      bool ok = true;
      for (int x=0;x<NrComputers;x++) if (Computer[x].jumpto>y) ok = false;
      if (ok) return y;
    }
  }
  return -1;
}



int main()
{
  IN.open("y2k.in");
  Run = 1;
  IN >> NrComputers;
  while (NrComputers!=0) {
   Input();
   cout << "Case #" << Run << ":\n";
   int year = GetYear();
   if (year==-1) cout << "Unknown bugs detected.\n\n";
   else cout << "The actual year is " << year << ".\n\n";
   IN >> NrComputers;
   Run++;
  }
  IN.close();
  return 0;
}
